// =====================================================================================================================
//  fennec-test, a program to execute unit tests for fennec
//  Copyright © 2025 - 2026  Medusa Slockbower
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <https://www.gnu.org/licenses/>.
// =====================================================================================================================

#include "tests/test_lang.h"
#include "tests/test_math.h"
#include "tests/test_memory.h"

#include "test.h"
#include "tests/test_containers.h"
#include "tests/test_core.h"
#include "tests/test_string.h"
#include "tests/test_format.h"
#include "tests/test_filesystem.h"
#include "tests/test_platform.h"
#include "tests/test_rtti.h"
#include "tests/test_threading.h"

int main(int, char **)
{
	srand(0);

	fennec_test_header("fennec-test, a program to execute unit tests for fennec");

	fennec_test_spacer(2);

	fennec_test_header("c++ language library");
	fennec_test_spacer(2);
	fennec::test::fennec_test_lang();
	fennec_test_spacer(3);

	fennec_test_header("containers library");
	fennec_test_spacer(2);
	fennec::test::fennec_test_containers();
	fennec_test_spacer(3);

	fennec_test_header("math library");
	fennec_test_spacer(2);
	fennec::test::fennec_test_math();
	fennec_test_spacer(3);

	fennec_test_header("string");
	fennec_test_spacer(2);
	fennec::test::fennec_test_string();
	fennec_test_spacer(3);

	fennec_test_header("format");
	fennec_test_spacer(2);
	fennec::test::fennec_test_format();
	fennec_test_spacer(3);

	fennec_test_header("filesystem");
	fennec_test_spacer(2);
	fennec::test::fennec_test_filesystem();
	fennec_test_spacer(3);

	fennec_test_header("threading");
	fennec_test_spacer(2);
	fennec::test::fennec_test_threading();
	fennec_test_spacer(3);

	fennec_test_header("rtti library");
	fennec_test_spacer(2);
	fennec::test::fennec_test_rtti();
	fennec_test_spacer(3);

	fennec_test_header("core library");
	fennec_test_spacer(2);
	fennec::test::fennec_test_core();
	fennec_test_spacer(3);

	fennec_test_header("platform library");
	fennec_test_spacer(2);
	fennec::test::fennec_test_platform();
	fennec_test_spacer(3);

	return 0;
}
